﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Windows.Media;
// Labor3
using System.Windows;

namespace CAD
{
    public class CADCircle : CADParent
    {

        private int x, y, radius;  // in mm
        private double strokeThickness;

        private DashStyle lineStyle;
        public Color brushFill;
        public Color brushLine;

        public int X
        {
            get { return x; }
            set { if (value > 0) x = value; }
        }
        public int Y
        {
            get { return y; }
            set { if (value > 0) y = value; }
        }
        public int Radius
        {
            get { return radius; }
            set { if (value > 0) radius = value; }
        }

        public CADCircle()
        {
            radius = 0;
            this.x = 0;
            this.y = 0;
            strokeThickness = 2;
            brushFill = Colors.Chartreuse;
            lineStyle = DashStyles.Solid;
            GraphicTyp = CADParent.GrfTypen.C_CIRCLE;
        }

        public CADCircle(CADCircle circle)
        {
            x = circle.x;
            y = circle.y;
            radius = circle.radius;
            strokeThickness = circle.strokeThickness;
            lineStyle = circle.lineStyle;
            brushFill = circle.brushFill;
            brushLine = circle.brushLine;
        }

        public CADCircle(int Mousex1, int Mousey1, int Mousex2, int Mousey2)
        {
            int x1, x2, y1, y2;
            if (Mousex1 < Mousex2)
            {
                x1 = Mousex1;
                x2 = Mousex2;
            }
            else
            {
                x1 = Mousex2;
                x2 = Mousex1;
            }

            if (Mousey1 < Mousey2)
            {
                y1 = Mousey1;
                y2 = Mousey2;
            }
            else
            {
                y1 = Mousey2;
                y2 = Mousey1;
            }

            if ((x2 - x1) < (y2 - y1))
                radius = (int)Math.Round((x2 - x1) * 0.5);
            else
                radius = (int)Math.Round((y2 - y1) * 0.5);


            this.x = x1 + radius; // (int)Math.Round((x1 + x2) * 0.5);
            this.y = y1 + radius; //  (int)Math.Round((y1 + y2) * 0.5);
            strokeThickness = 2;
            brushFill = Colors.Chartreuse;
            lineStyle = DashStyles.Solid;
            GraphicTyp = CADParent.GrfTypen.C_CIRCLE;
        }



        public double StrokeThickness
        {
            get { return strokeThickness; }
            set { if (strokeThickness > 0) strokeThickness = value; }
        }

        public DashStyle LineStyle
        {
            get { return lineStyle; }
            set { lineStyle = value; }
        }

        public override string ToString()
        {
            return "C: " + x + " / " + y + "   " + radius;
        }

        // Labor3
        public override void draw(DrawingContext dc, double zoom)
        {
            Pen pen;
            double dFactorMM = 94.5 / 25.4;  // Pixel pro mm
            double dF = dFactorMM * zoom;
            int gx = (int)Math.Round(x * dF);
            int gy = (int)Math.Round(y * dF);
            int gradius = (int)Math.Round(radius * dF);

            double thick = strokeThickness * zoom;
            if (thick <= 0.5) thick = 0.5;
            pen = new Pen(new SolidColorBrush(brushLine), thick);
            pen.DashStyle = lineStyle;
            dc.DrawEllipse(new SolidColorBrush(brushFill), pen, new Point(gx, gy), gradius, gradius);
        }

    }
}
