﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

// neu
using System.Globalization;


namespace CAD
{
    /// <summary>
    /// Interaktionslogik für EditRectangle.xaml
    /// </summary>
    public partial class EditRectangle : Window
    {
        CADRectangle _rect;

        private bool bRetCode = false;
        // bool bStart = true;

        public bool Retcode
        {
            get { return bRetCode; }
        }

        public CADRectangle Rectangle
        {
            get { return _rect; }
        }


        public EditRectangle(CADRectangle rect)
        {
            InitializeComponent();
            _rect = rect;;
            setGUI();
        }

        private void setGUI()
        {
            cbLineStyle.Items.Clear();
            cbLineStyle.Items.Add("Dash");
            cbLineStyle.Items.Add("DashDot");
            cbLineStyle.Items.Add("DashDotDot");
            cbLineStyle.Items.Add("Dot");
            cbLineStyle.Items.Add("Solid");

            tInputX1.Text = _rect.X1.ToString();
            tInputY1.Text = _rect.Y1.ToString();
            tInputX2.Text = _rect.X2.ToString();
            tInputY2.Text = _rect.Y2.ToString();

            cbLineStyle.SelectedIndex = 0;
            if (_rect.LineStyle == DashStyles.Dash) cbLineStyle.SelectedIndex = 0;
            if (_rect.LineStyle == DashStyles.DashDot) cbLineStyle.SelectedIndex = 1;
            if (_rect.LineStyle == DashStyles.DashDotDot) cbLineStyle.SelectedIndex = 2;
            if (_rect.LineStyle == DashStyles.Dot) cbLineStyle.SelectedIndex = 3;
            if (_rect.LineStyle == DashStyles.Solid) cbLineStyle.SelectedIndex = 4;
                       
            colorCanvas.Background = new SolidColorBrush(_rect.brushLine);
            colorContentCanvas.Background = new SolidColorBrush(_rect.brushFill);

            tInputLinewidth.Text = _rect.StrokeThickness.ToString("0.0", System.Globalization.CultureInfo.InvariantCulture);

        }

        private void bnOk_Click(object sender, RoutedEventArgs e)
        {
            int iValue = 0;
            double dValue = 0.0;
            bool bcanConvert;
            bcanConvert = int.TryParse(tInputX1.Text, out iValue);
            if (bcanConvert)
            {
                _rect.X1 = iValue;
            }

            bcanConvert = int.TryParse(tInputY1.Text, out iValue);
            if (bcanConvert)
            {
                _rect.Y1 = iValue;
            }

            bcanConvert = int.TryParse(tInputX2.Text, out iValue);
            if (bcanConvert)
            {
                _rect.X2 = iValue;
            }

            bcanConvert = int.TryParse(tInputY2.Text, out iValue);
            if (bcanConvert)
            {
                _rect.Y2 = iValue;
            }


            NumberStyles style = NumberStyles.AllowDecimalPoint;
            string sValue = tInputLinewidth.Text.Trim().Replace(",", ".");
            bcanConvert = double.TryParse(sValue, style, System.Globalization.CultureInfo.InvariantCulture, out dValue);
            if (bcanConvert)                
            {
                _rect.StrokeThickness = dValue;
            }


            switch (cbLineStyle.SelectedIndex)
            {
                case 0: _rect.LineStyle = DashStyles.Dash;
                    break;
                case 1: _rect.LineStyle = DashStyles.DashDot;
                    break;
                case 2: _rect.LineStyle = DashStyles.DashDotDot;
                    break;
                case 3: _rect.LineStyle = DashStyles.Dot;
                    break;
                case 4: _rect.LineStyle = DashStyles.Solid;
                    break;
            }
            bRetCode = true;
            Close();
        }

        private void bnCancel_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private void bnColor_Click(object sender, RoutedEventArgs e)
        {
            ColorDialog dialog = new ColorDialog();
            dialog.setColor(_rect.brushLine);
            dialog.ShowDialog();
            if (dialog.Retcode)
            {
                _rect.brushLine = Color.FromArgb(dialog.Alpha, dialog.Red, dialog.Green, dialog.Blue);
                colorCanvas.Background = new SolidColorBrush(_rect.brushLine);
            }

        }

        private void bnColorContent_Click(object sender, RoutedEventArgs e)
        {
            ColorDialog dialog = new ColorDialog();
            dialog.setColor(_rect.brushFill);
            dialog.ShowDialog();
            if (dialog.Retcode)
            {
                _rect.brushFill = Color.FromArgb(dialog.Alpha, dialog.Red, dialog.Green, dialog.Blue);
                colorContentCanvas.Background = new SolidColorBrush(_rect.brushFill);
            }
        }

    }
}
